//**************************************************************************
//**
//**	##   ##    ##    ##   ##   ####     ####   ###     ###
//**	##   ##  ##  ##  ##   ##  ##  ##   ##  ##  ####   ####
//**	 ## ##  ##    ##  ## ##  ##    ## ##    ## ## ## ## ##
//**	 ## ##  ########  ## ##  ##    ## ##    ## ##  ###  ##
//**	  ###   ##    ##   ###    ##  ##   ##  ##  ##       ##
//**	   #    ##    ##    #      ####     ####   ##       ##
//**
//**	Copyright (C) 1999-2001 Jnis Legzdi
//**
//**	This program is free software; you can redistribute it and/or
//**  modify it under the terms of the GNU General Public License
//**  as published by the Free Software Foundation; either version 2
//**  of the License, or (at your option) any later version.
//**
//**	This program is distributed in the hope that it will be useful,
//**  but WITHOUT ANY WARRANTY; without even the implied warranty of
//**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//**  GNU General Public License for more details.
//**
//**************************************************************************
//**
//**	Weaponn info table
//**
//**	Generated by makeinfo.
//**
//**************************************************************************

void set_weapon_staff(player_t *player);
void set_weapon_goldwand(player_t *player);
void set_weapon_crossbow(player_t *player);
void set_weapon_blaster(player_t *player);
void set_weapon_skullrod(player_t *player);
void set_weapon_phoenixrod(player_t *player);
void set_weapon_mace(player_t *player);
void set_weapon_gauntlets(player_t *player);
void set_weapon_beak(player_t *player);

weapon_func_t	weaponinfo[] =
{
	set_weapon_staff,
	set_weapon_goldwand,
	set_weapon_crossbow,
	set_weapon_blaster,
	set_weapon_skullrod,
	set_weapon_phoenixrod,
	set_weapon_mace,
	set_weapon_gauntlets,
	set_weapon_beak,
};

int weapon_ammo_type[] =
{
	am_noammo,
	am_goldwand,
	am_crossbow,
	am_blaster,
	am_skullrod,
	am_phoenixrod,
	am_mace,
	am_noammo,
	am_noammo,
};

//==========================================================================
//
//	set_weapon_staff
//
//==========================================================================

void set_weapon_staff(player_t *player)
{
	player->w_ammo = am_noammo;
	player->w_upstate = S_STAFFUP;
	player->w_downstate = S_STAFFDOWN;
	player->w_readystate = S_STAFFREADY;
	player->w_atkstate = S_STAFFATK1_1;
	player->w_holdatkstate = S_STAFFATK1_1;
	player->w_flashstate = S_NULL;
	player->w2_ammo = am_noammo;
	player->w2_upstate = S_STAFFUP2;
	player->w2_downstate = S_STAFFDOWN2;
	player->w2_readystate = S_STAFFREADY2_1;
	player->w2_atkstate = S_STAFFATK2_1;
	player->w2_holdatkstate = S_STAFFATK2_1;
	player->w2_flashstate = S_NULL;
}

//==========================================================================
//
//	set_weapon_goldwand
//
//==========================================================================

void set_weapon_goldwand(player_t *player)
{
	player->w_ammo = am_goldwand;
	player->w_upstate = S_GOLDWANDUP;
	player->w_downstate = S_GOLDWANDDOWN;
	player->w_readystate = S_GOLDWANDREADY;
	player->w_atkstate = S_GOLDWANDATK1_1;
	player->w_holdatkstate = S_GOLDWANDATK1_1;
	player->w_flashstate = S_NULL;
	player->w2_ammo = am_goldwand;
	player->w2_upstate = S_GOLDWANDUP;
	player->w2_downstate = S_GOLDWANDDOWN;
	player->w2_readystate = S_GOLDWANDREADY;
	player->w2_atkstate = S_GOLDWANDATK2_1;
	player->w2_holdatkstate = S_GOLDWANDATK2_1;
	player->w2_flashstate = S_NULL;
}

//==========================================================================
//
//	set_weapon_crossbow
//
//==========================================================================

void set_weapon_crossbow(player_t *player)
{
	player->w_ammo = am_crossbow;
	player->w_upstate = S_CRBOWUP;
	player->w_downstate = S_CRBOWDOWN;
	player->w_readystate = S_CRBOW1;
	player->w_atkstate = S_CRBOWATK1_1;
	player->w_holdatkstate = S_CRBOWATK1_1;
	player->w_flashstate = S_NULL;
	player->w2_ammo = am_crossbow;
	player->w2_upstate = S_CRBOWUP;
	player->w2_downstate = S_CRBOWDOWN;
	player->w2_readystate = S_CRBOW1;
	player->w2_atkstate = S_CRBOWATK2_1;
	player->w2_holdatkstate = S_CRBOWATK2_1;
	player->w2_flashstate = S_NULL;
}

//==========================================================================
//
//	set_weapon_blaster
//
//==========================================================================

void set_weapon_blaster(player_t *player)
{
	player->w_ammo = am_blaster;
	player->w_upstate = S_BLASTERUP;
	player->w_downstate = S_BLASTERDOWN;
	player->w_readystate = S_BLASTERREADY;
	player->w_atkstate = S_BLASTERATK1_1;
	player->w_holdatkstate = S_BLASTERATK1_3;
	player->w_flashstate = S_NULL;
	player->w2_ammo = am_blaster;
	player->w2_upstate = S_BLASTERUP;
	player->w2_downstate = S_BLASTERDOWN;
	player->w2_readystate = S_BLASTERREADY;
	player->w2_atkstate = S_BLASTERATK2_1;
	player->w2_holdatkstate = S_BLASTERATK2_3;
	player->w2_flashstate = S_NULL;
}

//==========================================================================
//
//	set_weapon_skullrod
//
//==========================================================================

void set_weapon_skullrod(player_t *player)
{
	player->w_ammo = am_skullrod;
	player->w_upstate = S_HORNRODUP;
	player->w_downstate = S_HORNRODDOWN;
	player->w_readystate = S_HORNRODREADY;
	player->w_atkstate = S_HORNRODATK1_1;
	player->w_holdatkstate = S_HORNRODATK1_1;
	player->w_flashstate = S_NULL;
	player->w2_ammo = am_skullrod;
	player->w2_upstate = S_HORNRODUP;
	player->w2_downstate = S_HORNRODDOWN;
	player->w2_readystate = S_HORNRODREADY;
	player->w2_atkstate = S_HORNRODATK2_1;
	player->w2_holdatkstate = S_HORNRODATK2_1;
	player->w2_flashstate = S_NULL;
}

//==========================================================================
//
//	set_weapon_phoenixrod
//
//==========================================================================

void set_weapon_phoenixrod(player_t *player)
{
	player->w_ammo = am_phoenixrod;
	player->w_upstate = S_PHOENIXUP;
	player->w_downstate = S_PHOENIXDOWN;
	player->w_readystate = S_PHOENIXREADY;
	player->w_atkstate = S_PHOENIXATK1_1;
	player->w_holdatkstate = S_PHOENIXATK1_1;
	player->w_flashstate = S_NULL;
	player->w2_ammo = am_phoenixrod;
	player->w2_upstate = S_PHOENIXUP;
	player->w2_downstate = S_PHOENIXDOWN;
	player->w2_readystate = S_PHOENIXREADY;
	player->w2_atkstate = S_PHOENIXATK2_1;
	player->w2_holdatkstate = S_PHOENIXATK2_2;
	player->w2_flashstate = S_NULL;
}

//==========================================================================
//
//	set_weapon_mace
//
//==========================================================================

void set_weapon_mace(player_t *player)
{
	player->w_ammo = am_mace;
	player->w_upstate = S_MACEUP;
	player->w_downstate = S_MACEDOWN;
	player->w_readystate = S_MACEREADY;
	player->w_atkstate = S_MACEATK1_1;
	player->w_holdatkstate = S_MACEATK1_2;
	player->w_flashstate = S_NULL;
	player->w2_ammo = am_mace;
	player->w2_upstate = S_MACEUP;
	player->w2_downstate = S_MACEDOWN;
	player->w2_readystate = S_MACEREADY;
	player->w2_atkstate = S_MACEATK2_1;
	player->w2_holdatkstate = S_MACEATK2_1;
	player->w2_flashstate = S_NULL;
}

//==========================================================================
//
//	set_weapon_gauntlets
//
//==========================================================================

void set_weapon_gauntlets(player_t *player)
{
	player->w_ammo = am_noammo;
	player->w_upstate = S_GAUNTLETUP;
	player->w_downstate = S_GAUNTLETDOWN;
	player->w_readystate = S_GAUNTLETREADY;
	player->w_atkstate = S_GAUNTLETATK1_1;
	player->w_holdatkstate = S_GAUNTLETATK1_3;
	player->w_flashstate = S_NULL;
	player->w2_ammo = am_noammo;
	player->w2_upstate = S_GAUNTLETUP2;
	player->w2_downstate = S_GAUNTLETDOWN2;
	player->w2_readystate = S_GAUNTLETREADY2_1;
	player->w2_atkstate = S_GAUNTLETATK2_1;
	player->w2_holdatkstate = S_GAUNTLETATK2_3;
	player->w2_flashstate = S_NULL;
}

//==========================================================================
//
//	set_weapon_beak
//
//==========================================================================

void set_weapon_beak(player_t *player)
{
	player->w_ammo = am_noammo;
	player->w_upstate = S_BEAKUP;
	player->w_downstate = S_BEAKDOWN;
	player->w_readystate = S_BEAKREADY;
	player->w_atkstate = S_BEAKATK1_1;
	player->w_holdatkstate = S_BEAKATK1_1;
	player->w_flashstate = S_NULL;
	player->w2_ammo = am_noammo;
	player->w2_upstate = S_BEAKUP;
	player->w2_downstate = S_BEAKDOWN;
	player->w2_readystate = S_BEAKREADY;
	player->w2_atkstate = S_BEAKATK2_1;
	player->w2_holdatkstate = S_BEAKATK2_1;
	player->w2_flashstate = S_NULL;
}

